Bug 889 - add pread/pwrite vfs operations
add pread/pwrite vfs operations
Status: CLOSED FIXED
Product: Samba 3.0
Classification: Unclassified
Component: File Services
3.0.0
All All
: P3 normal
: none
Assigned To: Gerald (Jerry) Carter
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2003-12-15 19:38 UTC by James Peach
Modified: 2005-08-24 10:17 UTC (History)
0 users

See Also:


Attachments
add pread/pwrite vfs ops (17.30 KB, patch)
2003-12-15 20:38 UTC, James Peach
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description James Peach 2003-12-15 19:38:03 UTC
The pending diff adds pread/pwrite operations to the VFS layer and makes
use of them in the I/O path. The profiling stats are updated
correspondingly.

There is not much performance advanage additional to using spinlocks (a
consistent 2% - 7% increase in throughput), but there is a significant
benefit to using p{read,write} with fcntl tdb locking (5% - 30% increase in
throughput). The largest improvements are in high packet rate workloads (ie,
small blocks sizes and meta-data workloads), as you might expect.

I can provide detailed numbers (packet rate, cpu usage, NIC throughput, etc)
if that would be useful.
Comment 1 James Peach 2003-12-15 20:38:57 UTC
Created attachment 325 [details]
add pread/pwrite vfs ops
Comment 2 Jeremy Allison 2004-01-06 09:29:27 UTC
Slightly modified version of patch applied for 3.0.2.
Jeremy.
Comment 3 Gerald (Jerry) Carter 2005-08-24 10:17:12 UTC
sorry for the same, cleaning up the database to prevent unecessary reopens of bugs.